
@ECHO OFF
@title "LEM218 Firmware Flashing"

ECHO "== Beginning install of the Microsoft VC++ library - confirm installation as directed by the installer =="

FOR %%F IN (*.hex) DO (
 set filename=%%F
 goto :begin
)
:begin
ECHO "We will be installing firmware file: %filename%"

sendmidi list
ECHO "%errorlevel%"

IF "%errorlevel%"=="0" (goto :dfumode) ELSE (goto :installvcp)

:installvcp
set /P c=Is this a 64-bit system? (Y/N)
cls
if /I "%c%" EQU "Y" goto :sixtyfour
if /I "%c%" EQU "N" goto :thirtytwo
cls

:sixtyfour
VC_redist.x64.exe /install /passive /norestart
goto :donevcp

:thirtytwo
VC_redist.x86.exe /install /passive /norestart

:donevcp
set /P c=Are you finished installing the VC++ library? (Y/N)
cls
if /I "%c%" EQU "Y" goto :dfumode
if /I "%c%" EQU "N" goto :Failed
cls

:dfumode
ECHO "==Putting Buchla 218 into Firmware Flashing Mode=="

sendmidi list
sendmidi dec
sendmidi.exe dev 218e syx 0 2 55 2 1 1

set /P c=Press Y to Continue (Y/N)
cls
if /I "%c%" EQU "Y" goto :Passed1
if /I "%c%" EQU "N" goto :Failed
cls

:Passed1
ECHO "== Launching Zadig to install the libusb driver =="
ECHO "== Zadig executable is under GPLv3 from https://zadig.akeo.ie/ =="

zadig-2.8.exe
set /P c=Go to the Zadig window and press "Install Driver" then return to this window and Y to continue or N if there is a problem (Y/N)
cls
if /I "%c%" EQU "Y" goto :Passed2
if /I "%c%" EQU "N" goto :Failed
cls


:Passed2
ECHO "==Begin Buchla 218 Firmware Flashing=="

dfu-programmer at32uc3b1256 erase --force

dfu-programmer at32uc3b1256 flash --suppress-bootloader-mem %filename%

set /P c=Press Y to Restart the 218e (Y/N)
cls
if /I "%c%" EQU "Y" goto :Passed3
if /I "%c%" EQU "N" goto :Failed
cls

:Passed3
dfu-programmer at32uc3b1256 start

ECHO "==Flashing ended=="


:Failed
ECHO "==Flashing Ended By User=="

:Exit
ECHO "==Flashing Complete=="
